
Month subclass: #JulianMonth
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

!JulianMonth class publicMethods !

defaultDateList
	"self defaultDateList"
	| aDate firstDate lastDate |

	aDate := Date today.
	firstDate :=  (Date 	newDay: 1 
									month: aDate monthName 
									year: aDate year).
	lastDate := 	(Date 	newDay: (Date daysInMonth: aDate monthName forYear: aDate year) 
									month: aDate monthName
									year: aDate year).

	^(Interval 	from:	firstDate daysFromBaseDay
					to:		lastDate daysFromBaseDay)
								collect: [:dateDay | Date fromDays: dateDay].
!

fromDate: aDate
	"instantiates a Month object for which aDate belongs to"
	"self fromDate: Date today"
	| firstDate lastDate |

	firstDate :=  (Date 	newDay: 1 
									month: aDate monthName
									year: aDate year).
	lastDate := 	(Date 	newDay: (Date daysInMonth: aDate monthName forYear: aDate year) 
									month: aDate monthName
									year: aDate year).
	^self new
		dateList: ((Interval 	from:	firstDate daysFromBaseDay
											to:	lastDate daysFromBaseDay)
								collect: [:dateDay | Date fromDays: dateDay]).

!

fromMonth: aMonth year: aYearIndex
	"instantiates a Month object for which aDate belongs to"
	"self fromMonth: 'February' year: 1996"
	| firstDate lastDate |

	firstDate :=  (Date 	newDay: 1 
									month: aMonth
									year: aYearIndex).
	lastDate := 	(Date 	newDay: (Date daysInMonth: aMonth forYear: aYearIndex) 
									month: aMonth
									year: aYearIndex).
	^self new
		dateList: ((Interval 	from:	firstDate daysFromBaseDay
											to:	lastDate daysFromBaseDay)
								collect: [:dateDay | Date fromDays: dateDay]).

!

fromMonthIndex: aMonthIndex year: aYearIndex
	"instantiates a Month object for which aDate belongs to"
	"self fromMonthIndex: 4 year: 1998"
	| firstDate lastDate |

	firstDate :=  (Date 	newDay: 1 
									monthIndex: aMonthIndex
									year: aYearIndex).
	lastDate := 	(Date 	newDay: (Date daysInMonth: (Date nameOfMonth: aMonthIndex) forYear: aYearIndex) 
									monthIndex: aMonthIndex
									year: aYearIndex).
	^self new
		dateList: ((Interval 	from:	firstDate daysFromBaseDay
											to:	lastDate daysFromBaseDay)
								collect: [:dateDay | Date fromDays: dateDay]).

!

monthNames
	"self monthNames"
	^(1 to: self monthsInYear) collect: [:monthIndex | (Date nameOfMonth: monthIndex) asString]!

monthsInYear
	^12
! !

!JulianMonth publicMethods !

weekList
	"answers a collection of SevenDayWeek instances"
	| aCollection |
	aCollection := OrderedCollection new.

	self dateList do: [:aDate |
		self dateList first = aDate
			ifTrue: [
				aCollection add: (SevenDayWeek fromDate: aDate)].

		(aDate dayIndex = 7 and: [aDate dayOfMonth > 7])
			ifTrue: [
				(aDate dayOfMonth >= aDate dayIndex) &
				(aDate dayOfMonth < (Date daysInMonth: aDate monthName forYear: aDate year))
					ifTrue: [
						aCollection add: (SevenDayWeek fromDate: aDate)]].

		self dateList last = aDate
			ifTrue: [
				aCollection add: (SevenDayWeek fromDate: aDate)]].

	^aCollection


! !

JulianMonth initializeAfterLoad!